<!--

_letter-jslib
A javascript library for modifying "letters" that are created by converting HTML 
to PDF wherein the PDF generator supports javascript and CSS.
1.2.4
david.mcmeans@live.com

MIT License

Copyright (c) 2015 David Sidney McMeans 

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE. 

 -->

<script>
	//https://stackoverflow.com/questions/610406/javascript-equivalent-to-printf-string-format
	if (!String.prototype.format) {
		String.prototype.format = function() {
			var args = arguments;
			return this.replace(/{(\d+)}/g, function(match, number) {
				return typeof args[number] != 'undefined' ? args[number] : match;
			});
		};
	}
	if (!String.prototype.formatFromArray) {
		String.prototype.formatFromArray = function(arr) {
			return this.replace(/{(\d+)}/g, function(match, number) {
				return typeof arr[number] != 'undefined' ? arr[number] : match;
			});
		};
	}
	// "{0} is true, but {1} is not {0} {2}".format("True", "False");
	//console.log('{0} {1} {1}'.formatFromArray(['One','Two']));

	// Pass in the objects to merge as arguments.
	// For a deep extend, set the first argument to true.
	var extend = function() {

		// Variables
		var extended = {};
		var deep = false;
		var i = 0;
		var length = arguments.length;

		// Check if a deep merge
		if (Object.prototype.toString.call(arguments[0]) === '[object Boolean]') {
			deep = arguments[0];
			i++;
		}

		// Merge the object into the extended object
		var merge = function(obj) {
			for ( var prop in obj) {
				if (Object.prototype.hasOwnProperty.call(obj, prop)) {
					// If deep merge and property is an object, merge properties
					if (deep && Object.prototype.toString.call(obj[prop]) === '[object Object]') {
						extended[prop] = extend(true, extended[prop], obj[prop]);
					} else {
						extended[prop] = obj[prop];
					}
				}
			}
		};

		// Loop through each object and conduct a merge
		for (; i < length; i++) {
			var obj = arguments[i];
			merge(obj);
		}

		return extended;

	};

	var dbg = {
		ALL : 0,
		DEBUG : 1,
		INFO : 2,
		WARN : 3,
		dbgLevel : 2, // default INFO
		LOG_LEVELS : [ 'ALL', 'DEBUG', 'INFO', 'WARN' ],
		messages : '',

		add : function(line) {
			this.messages += '<p>' + line + '</p>';
		},
		log : function(level, context, line) {
			if (level >= dbg.dbgLevel) {
				var buf = ('     ' + dbg.LOG_LEVELS[level]).slice(-5);
				this.messages += '<p>' + buf + ' ' + context + ': ' + line + '</p>';
			}
		},
		show : function(opt) {
			var p = {
				debugContainerSelector : '.debug-content',
				debugClass : 'debug'
			};
			if (typeof opt === 'object') {
				p = extend(p, opt);
			}

			var obj = document.querySelector(p.debugContainerSelector);
			if (obj) {
				if (this.messages !== '') {
					var html = '<h1>Messages:</h1><pre class="{c}">'.replace('{c}', p.debugClass) + this.messages + '</pre>';
					obj.innerHTML = html;
				}
			} else {
				console.log('Debug container ' + p.debugContainerSelector + ' not found.');
			}

		}
	}

	const VAL_NOTBLANK = 'not()';

	var monthList = [ "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November",
			"December" ];
	var monList = [ "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" ];

	function getDateParts(s) {
		// s is like 05-Oct-2016, convert to date parts
		var result = {
			year : 1900,
			month : 0,
			day : 1
		}
		if (/\d{2}-\w{3}-\d{4}/.test(s)) {
			var list = s.split('-');
			result.year = parseInt(list[2]);
			result.month = monList.indexOf(list[1]);
			result.day = parseInt(list[0]);
		}

		return result;
	}

	function getDateFromParts(s) {
		// s is like 05-Oct-2016, or a date object
		if (s instanceof Date) {
			return s;
		} else {
			var dp = getDateParts(s);
			var myDate = new Date(dp.year, dp.month, dp.day);
			return myDate;
		}
	}

	function formatDate(s, format) {
		// s is like 05-Oct-2016
		var f = 'formatDATE'; //arguments.callee.name;
		//dbg.log(dbg.DEBUG, f + '(s=' + s + ',format=' + format + ')', 'START');

		var myDate = getDateFromParts(s), result = '';

		//dbg.log(dbg.DEBUG, f, 'date=' + myDate.toDateString());

		if (s && s !== '') {
			var month = monthList[myDate.getMonth()];
			switch (format) {
			case 'DD Mon YYYY':
				result = s.replace(/-/g, ' ');
				break;
			case 'Month DD, YYYY':
			default:
				result = month + ' ' + myDate.getDate() + ', ' + myDate.getFullYear();
			}
		}

		//dbg.log(dbg.DEBUG, f, 'result=' + result);
		//dbg.log(dbg.DEBUG, f, 'FINISH');

		return result;
	}

	var DateDiff = {

		inDays : function(d1, d2) {
			// get one day in milliseconds
			var oneDay = 24 * 3600 * 1000;

			// convert date to milliseconds
			var t2 = d2.getTime();
			var t1 = d1.getTime();

			return Math.round((t2 - t1) / (oneDay));
		},

		inWeeks : function(d1, d2) {
			// get one week in milliseconds
			var oneWeek = 24 * 3600 * 1000 * 7;

			// convert date to milliseconds
			var t2 = d2.getTime();
			var t1 = d1.getTime();

			return Math.round((t2 - t1) / (oneWeek));
		},

		inMonths : function(d1, d2) {
			var d1Y = d1.getFullYear();
			var d2Y = d2.getFullYear();
			var d1M = d1.getMonth();
			var d2M = d2.getMonth();

			return (d2M + 12 * d2Y) - (d1M + 12 * d1Y);
		},

		inYears : function(d1, d2) {
			return d2.getFullYear() - d1.getFullYear();
		}
	}

	function formatDates(format) {
		if (format === undefined) {
			format = 'Month DD, YYYY';
		}
		var f = arguments.callee.name;

		dbg.log(dbg.DEBUG, f + '("{0}")'.format(format), 'START');

		var items = document.querySelectorAll('.content .date');
		for (var i = 0; i < items.length; i++) {
			var item = items[i];
			dbg.log(dbg.DEBUG, f, 'index=' + i + ' html=' + item.innerHTML + ' text=' + item.textContent);
			item.textContent = formatDate(item.textContent, format);
		}
		dbg.log(dbg.DEBUG, f, 'FINISH');
	}

	function isEmpty(s) {
		return (typeof s === 'undefined' || s === null || s.trim() === '') ? true : false;
	}

	function initialValue(s, defValue) {
		var v = (isEmpty(s)) ? defValue : s.trim();

		if (typeof v === 'string') {
			if (v.toLowerCase() === 'true') {
				v = true;
			} else if (v.toLowerCase() === 'false') {
				v = false;
			}
		}

		return v;
	}

	function _getDataObjectRegexes(item) {
		var obj = {
			regex : [],
			subst : []
		}

		// get regex and subst lists, 
		// Ex. data-regex, data-regex-1, data-regex-2
		//     data-subst, data-subst-1, data-subst-2
		for (var j = 0; j < 10; j++) {
			var r_attrib = 'data-regex' + ((j > 0) ? '-' + j : '');
			var s_attrib = 'data-subst' + ((j > 0) ? '-' + j : '');

			regexVal = item.getAttribute(r_attrib);
			//console.log('getData: regex', j, r_attrib, s_attrib, regexVal, isEmpty(regexVal));
			if (isEmpty(regexVal)) {
				//console.log('getData: break', j);
				break;
			} else {
				obj.regex.push(regexVal);
				obj.subst.push(initialValue(item.getAttribute(s_attrib), ''));
			}
		}

		return obj;
	}

	function _getDataObject(item, c, value) {
		var obj = {
			value : value,
			problem : initialValue(item.getAttribute('data-problem'), '<b>{0}</b> is <em>{1}</em>. Expected to see <em>{2}</em>!'),
			expectedValue : initialValue(item.getAttribute('data-expected-value'), VAL_NOTBLANK),
			fix : initialValue(item.getAttribute('data-fix'), ''),
			help : initialValue(item.getAttribute('data-help'), ''), // override for problem and fix
			label : initialValue(item.getAttribute('data-label'), c), // field name
			blankValue : initialValue(item.getAttribute('data-blank-value'), ''),
			required : initialValue(item.getAttribute('data-required'), true),
			type : initialValue(item.getAttribute('data-type'), 'text'),
			format : initialValue(item.getAttribute('data-format'), ''),
			template : initialValue(item.getAttribute('data-template'), ''),
			combineWith : initialValue(item.getAttribute('data-combine-with'), ''),
			rowTemplate : initialValue(item.getAttribute('data-row-template'), ''),
			exclude : initialValue(item.getAttribute('data-exclude'), ''),
			replace : initialValue(item.getAttribute('data-replace'), ''),
			replaceWith : initialValue(item.getAttribute('data-replace-with'), ''),
			replaceOutput : initialValue(item.getAttribute('data-replace-output'), false),
			defaultValue : initialValue(item.getAttribute('data-default-value'), ''),
			customTreatment : initialValue(item.getAttribute('data-custom-treatment'), ''),
			regex : [],
			subst : [],
			booleanValue : null,
		}

		var regObj = _getDataObjectRegexes(item);
		obj.regex = regObj.regex;
		obj.subst = regObj.subst;

		if (obj.required === 'false') {
			obj.required = false;
		}
		// default date format
		if (obj.type === 'date' && obj.format === '') {
			obj.format = 'Month DD, YYYY';
		}
		// boolean value
		if (obj.type === 'boolean' && obj.value !== obj.blankValue) {
			obj.booleanValue = truthy(obj.value);
		}

		return obj;
	}

	function getData() {
		var obj = {};

		var children = document.querySelector('.data').children;
		for (var i = 0; i < children.length; i++) {
			var item = children[i];
			var c = item.className;
			var value = item.innerHTML.trim();

			// Help: {0} = element label
			// Expected value help: {0} - element label, {1} - value, {2} - expected value

			obj[c] = _getDataObject(item, c, value);

			// validation is done in applyData() so that all data fields are available
		}
		return obj;
	}

	function applyData(obj) {

		// pre-process
		for ( var prop in obj) {
			if (obj.hasOwnProperty(prop)) {
				var item = obj[prop];
				if (item.combineWith) {
					var valList = [ item.value ];
					var propList = item.combineWith.split(',');
					for (i = 0; i < propList.length; i++) {
						var v = obj[propList[i]].value;
						//console.log(propList[i], v);
						valList.push(obj[propList[i]].value);
					}
					obj[prop].valueOriginal = item.value;
					// console.log(propList, valList);

					if (item.rowTemplate !== '') {
						item.list = formatData({
							input : item.value,
							inputFormat : item.type,
							exclude : item.exclude,
							outputFormat : 'list'
						});
						for (var i = 0; i < propList.length; i++) {
							var p = obj[propList[i]];
							obj[propList[i]].list = formatData({
								input : p.value,
								inputFormat : p.type,
								exclude : item.exclude,
								outputFormat : 'list'
							});
						}

						item.value = '';
						for (var i = 0; i < item.list.length; i++) {
							var rowValList = [ item.list[i] ];
							for (var r = 0; r < propList.length; r++) {
								rowValList.push(obj[propList[r]].list[i]);
							}
							var row = item.rowTemplate.formatFromArray(rowValList);
							item.value += row;
						}
					} else {
						obj[prop].value = item.template.formatFromArray(valList);
					}
				}
			}
		}

		for ( var prop in obj) {
			if (prop && obj.hasOwnProperty(prop)) {
				var selector = '.content .' + prop;
				var item = obj[prop];

				// apply default value if blank - DONE IN FORMATDATA
				//if (item.defaultValue !== '') {
				//  if (item.value == item.blankValue) {
				//    item.value = item.defaultValue;
				//  }
				//}

				// prep default value - can use another value is already defined
				// if default-value like {{ already_defined_valued }} then already_defined_value is used as default
				if (item.defaultValue.startsWith('{{') && item.defaultValue.endsWith('}}')) {
					dbg.log(dbg.DEBUG, 'applyData', '{0}: defVal {1} has token markers {{ }}'.format(prop, item.defaultValue));
					var token = '';
					try {
						token = item.defaultValue.match(/{{\s(.+?)\s}}/)[1];
					} catch (e) {
					}
					if (token !== '' && obj[token].value !== '') {
						item.defaultValue = obj[token].value;
						dbg.log(dbg.DEBUG, 'applyData', '{0}: defVal set to {1}'.format(prop, item.defaultValue));
					}
				}

				var val = obj[prop].value;
				var isReq = obj[prop].required;
				var help = obj[prop].help;
				var type = obj[prop].type;
				var format = obj[prop].format;
				var template = obj[prop].template;

				if (type === 'date') {
					console.log('date', item);
					if (val === '[lastOfMonth]') {
						var d = getLastDayOfMonth();
						val = formatDate(d, item.format);
						console.log('last of month', d, val);
					} else if (val !== '') {
						val = formatDate(val, item.format);
					}
				}

				switch (type) {
				case 'text':
				case 'lines':
				case 'tildeString':
				case 'boolean':

					val = formatData({
						input : val,
						exclude : item.exclude,
						replace : item.replace,
						replaceWith : item.replaceWith,
						replaceOutput : item.replaceOutput,
						inputFormat : item.type,
						outputFormat : item.format,
						blankValue : item.blankValue,
						defaultValue : item.defaultValue,
						regex : item.regex,
						subst : item.subst,
					});

					break;
				}

				// validate
				//console.log(selector, val, isReq, help);
				if (item.expectedValue !== '') {
					var expectedVal, op;
					//console.log('preswitch', notVal, val, item.expectedValue, op);
					if (/(not|equals|contains)\(.*\)/.test(item.expectedValue)) {
						var m = /(not|equals|contains)\((.*)\)/.exec(item.expectedValue);
						op = m[1];
						expectedVal = m[2];
					} else {
						op = 'equals';
						expectedVal = item.expectedValue;
					}

					//var verb = ({not:'not equal', equals:'equal', contains:'contain'})[op];
					//console.log(op+': val [' + val + '] should '+verb+' [' +  expectedVal + ']');

					//console.log('postswitch', notVal, val, item.expectedValue, op);
					switch (op) {
					case 'not':
						//only need required if item.blankValue?
						if (val === expectedVal && item.required) {
							// {0} - element label
							var help = item.help;
							if (item.help === '') {
								// remove expected value if not value is blank
								var problem = (expectedVal === '') ? item.problem.replace('. Expected to see <em>{2}</em>', '')
										: item.problem.replace('. Expected to see <em>{2}</em>', '. Expected not to see <em>{2}</em>');
								help = problem.format(item.label, (val === '') ? 'blank' : val, expectedVal) + ' ' + item.fix;
							}
							dbg.log(dbg.INFO, 'applyData', help);
						}
						break;
					case 'contains':
						if (!val.includes(expectedVal) && item.required) {
							// {0} - element label, {1} - value, {2} - expected value
							var help = item.help;
							if (item.help === '') {
								var problem = item.problem.replace('. Expected to see <em>{2}</em>', '. Expected to contain <em>{2}</em>');
								help = problem.format(item.label, val, expectedVal) + ' ' + item.fix;
							}
							dbg.log(dbg.INFO, 'applyData', help);
						}
						break;
					case 'equals':
						if (val !== expectedVal && item.required) {
							// {0} - element label, {1} - value, {2} - expected value
							var help = item.help;
							if (item.help === '') {
								help = item.problem.format(item.label, val, expectedVal) + ' ' + item.fix;
							}
							dbg.log(dbg.INFO, 'applyData', help);
						}
					default:
					}

				}

				// apply template after validation and format and type changes
				if (item.template !== '' && (item.value !== item.blankValue)) {
					val = item.template.format(val);
				}

				list = document.querySelectorAll(selector);
				for (var i = 0; i < list.length; i++) {
					list[i].innerHTML = val;
				}
			}
		}
	}

	function cleanMSWord(s) {
		if (s.indexOf('â€¢\t') >= 0) {
			//if (s.indexOf('<br>') === -1) {
			//    s = s.replace(/â€¢\t/g, '<br>');
			//    s = s.replace(/^<br>/, '');
			//} else {
			s = s.replace(/â€¢\t/g, '');
			//}
		}

		var r = String.fromCharCode(61607) + '\t';
		var regex = new RegExp(r, 'g');
		if (regex.test(s)) {
			s = s.replace(regex, '&bull;&nbsp;&nbsp;&nbsp;&nbsp;');
		}

		return s;
	}

	function removeBlankLines(s) {
		s = s.replace(/^\s*[\r\n]/gm, '');
		s = s.replace(/[\r\n]$/, '');
		s = s.replace(/<br>$/, '');
		// s = s.replace(/[<br>]{2,}/g, '<br>');
		// s = s.replace(/[<br>]{1,}$/, '');
		return s;
	}

	/**
	 * return true for true-like values observed in the letters
	 */
	function truthy(val) {
		var result = false;
		if (val != 0) {
			if (val == '1' || val.toLowerCase() == 'y' || val.toLowerCase() == 'yes') {
				result = true;
			}
		}
		return result;
	}

	function isArray(a) {
		var status = false;
		status = (Array.isArray(a));
		//status = (a instanceof Array);
		//status = (a.constructor === Array);
		return status;
	}

	function formatData(opt) {
		var f = arguments.callee.name;
		var p = {
			inputFormat : 'tildeString', // lines, tildeString, boolean
			outputFormat : 'commasOxford', // commas, commasOxford, bullet, ol, ul, ol+, ul+, yn
			cleanMSWord : true,
			removeBlankLines : true,
			input : '',
			inputSelector : null,
			outputSelector : null,
			data : null,
			dataKey : null,
			exclude : '',
			template : '',
			replace : '',
			replaceWith : '',
			replaceOutput : false,
			blankValue : '',
			defaultValue : '',
			regex : [],
			subst : [],
		};
		if (typeof opt === 'object') {
			p = extend(p, opt);
		}
		var result = '', list = [];

		dbg.log(dbg.DEBUG, f, 'START inputFormat={4} input={0}, replace={1}, replaceOutput={2}, with={3}'.format(p.input, p.replace,
				p.replaceOutput, p.replaceWith, p.inputFormat));

		if (p.data && p.dataKey) {
			if (!p.data[p.dataKey]) {
				dbg.log(dbg.WARN, f, 'Data object has no property ' + p.dataKey);
			} else {
				p.input = p.data[p.dataKey].value;
			}
		} else if (p.inputSelector) {
			var input = document.querySelector(p.inputSelector).innerHTML;
			//console.log({                input: input            });
			p.input = input;
		}

		if (p.exclude !== '') {
			if ((new RegExp(p.exclude)).test(p.input)) {
				p.input = p.input.replace(p.exclude, '');
			} else {
				dbg.log(dbg.DEBUG, f, 'Exclude value ' + p.exclude + ' not found in input ' + p.input);
			}
		}

		if (p.replace !== '' && !p.replaceOutput && typeof result === 'string') {
			var t = isRegex(p.replace);
			dbg.log(dbg.DEBUG, f, 'Replace input value ' + p.replace + ' (isRegex=' + t.isRegex + ') in input ' + p.input);

			var r = (t.isRegex) ? new RegExp(t.regex, t.modifiers) : new RegExp(p.replace);

			if (r.test(p.input)) {
				p.input = p.input.replace(r, p.replaceWith);
			} else {
				dbg.log(dbg.DEBUG, f, 'Replace value ' + p.replace + ' not found in input ' + p.input);
			}
		}

		if (p.replace !== '' && !p.replaceOutput) {
			if ((new RegExp(p.replace)).test(p.input)) {
				p.input = p.input.replace(p.replace, p.replaceWith);
			} else {
				dbg.log(dbg.DEBUG, f, 'Replace value ' + p.replace + ' not found in input ' + p.input);
			}
		}

		switch (p.inputFormat) {
		case 'boolean':
			// store temp boolean value in result
			result = truthy(p.input);
			break;

		case 'tildeString':
			if (p.removeBlankLines) {
				p.input = p.input.replace(/[~]$/, '')
			}
			;
			list = p.input.split('~');
			console.log(f, p, list);
			break;
		case 'lines':
			if (p.cleanMSWord) {
				p.input = cleanMSWord(p.input)
			}
			;
			if (p.removeBlankLines) {
				p.input = removeBlankLines(p.input)
			}
			;
			list = p.input.split(/\n<br>|\r\n|\r|\n|<br>/g);
			if (list.length === 1 && list[0] === '') {
				list = [];
			}
			break;
		}

		// apply regex replace to list items
		console.log('formatData: Regex is array', isArray(p.regex));
		if (isArray(p.regex) && isArray(p.subst) && list.length > 0) {
			for (var j = 0; j < p.regex.length; j++) {
				var t = isRegex(p.regex[j]);
				var r = (t.isRegex) ? new RegExp(t.regex, t.modifiers) : new RegExp(p.regex[j]);
				for (var i = 0; i < list.length; i++) {
					var item = list[i].replace(r, p.subst[j]);
					list[i] = item;
				}
			}
			console.log('list regex replace', list, p);

		}

		switch (p.outputFormat) {
		case 'yn':
			// temp bool value is in result
			result = (result) ? 'Y' : 'N';
			break;
		case 'checkbox':
			result = (result) ? '&#9745;' : '&#9744;';
			break;

		case 'bullet':
		case 'bullets':
			result = list.join(' &bull; ');
			break;
		case 'breaks':
			result = list.join('<br>');
			break;
		case 'commas':
		case 'commasOxford':
			var and = (list.length <= 1) ? '' : (list.length > 2 && p.outputFormat === 'commasOxford') ? ', and ' : ' and ';
			var last = list.pop();
			result = list.join(', ') + and + last;
			break;
		case 'ol':
		case 'ul':
		case 'ol+':
		case 'ul+':
		case 'ul-':
			if (list.length > 0) {
				if (list.length === 1 && p.outputFormat.indexOf('+') > 0) {
					result = list.pop(); // simple string
				} else {
					var classes = (p.outputFormat.indexOf('-') > 0) ? 'no-bullet' : '';

					var tag = p.outputFormat.replace(/[+-]/, '');
					result = '<{0} class="{1}"><li>'.format(tag, classes) + list.join('</li><li>') + '</li></{0}>'.format(tag);
				}

			}

			break;
		case 'list':
			result = list; // return data as array
			break;

		case 'periodMonths':
			// expect input to be tildeString list
			result = '';
			if (list.length > 1) {
				var beginDate = list[0];
				var endDate = list[1];
				var numMonths = getApprovalPeriodInMonths({
					beginDate : beginDate,
					endDate : endDate
				});
				result = numMonths.toString();
			}
			break;

		case 'periodDays':
			// expect input to be tildeString list
			result = '';
			if (list.length > 1) {
				var beginDate = list[0];
				var endDate = list[1];
				var numDays = getDateDiffInDays({
					beginDate : beginDate,
					endDate : endDate
				});
				result = numDays.toString();
			}
			break;

		default:
			result = p.input;
		}

		if (p.inputFormat === 'date') {
			result = formatDate(p.input, p.outputFormat);
		}

		// apply default value if current value is blank
		if (p.defaultValue !== '' && result == p.blankValue) {
			console.log('formatData setting from default', p);
			result = p.defaultValue;
		}

		// apply replace to output
		if (p.replace !== '' && p.replaceOutput && typeof result === 'string') {
			var t = isRegex(p.replace);
			dbg.log(dbg.DEBUG, f, 'Replace output value ' + p.replace + ' (isRegex=' + t.isRegex + ') in input ' + p.input);
			if (t.isRegex) {
				var r = new RegExp(t.regex, t.modifiers);
				result = result.replace(r, p.replaceWith);

			} else {
				result = result.replace(p.replace, p.replaceWith);
			}
		}

		// apply template last
		if (p.template !== '' && typeof result === 'string' && result !== '') {
			result = p.template.format(result);
		}

		if (p.data && p.dataKey && p.data[p.dataKey]) {
			p.data[p.dataKey].value = result;
		} else if (p.outputSelector) {
			document.querySelector(p.outputSelector).innerHTML = result;
		}

		dbg.log(dbg.DEBUG, f, 'FINISH');

		return result;

	}

	/**
	 * is the given string a regex?
	 */
	function isRegex(s) {
		var status = {
			isRegex : false,
			regex : '',
			modifiers : ''
		}

		const regex = /^\/(.+)\/(.*)/;
		var result = s.match(regex);
		if (result != null && result.length > 1) {
			status.regex = result[1];
			status.modifiers = result[2];
			status.isRegex = true;
		}
		return status;
	}

	/*
	 * endDate in an "approval" period is one day short of 3,6,12,36 month period
	 **/
	function getApprovalPeriodInMonths(opt) {
		var f = arguments.callee.name;
		var p = {
			beginDateSelector : '', // .data .study-approval-date
			endDateSelector : '', // .data .study-expiration-date
			beginDate : '',
			endDate : ''
		};
		if (typeof opt === 'object') {
			p = extend(p, opt);
		}

		if (p.beginDateSelector !== '') {
			p.beginDate = document.querySelector(p.beginDateSelector).textContent;
		}
		if (p.endDateSelector !== '') {
			p.endDate = document.querySelector(p.endDateSelector).textContent;
		}

		var beginDate = getDateFromParts(p.beginDate);
		var endDate = getDateFromParts(p.endDate);

		endDate.setDate(endDate.getDate() + 1); // endDate is one day short of 3,6,12,36 month period
		var result = DateDiff.inMonths(beginDate, endDate);

		//console.log(f,p,result);

		return result;
	}

	function getDateDiffInDays(opt) {
		var f = arguments.callee.name;
		var p = {
			beginDateSelector : '', // .data .study-approval-date
			endDateSelector : '', // .data .study-expiration-date
			beginDate : '',
			endDate : ''
		};
		if (typeof opt === 'object') {
			p = extend(p, opt);
		}

		if (p.beginDateSelector !== '') {
			p.beginDate = document.querySelector(p.beginDateSelector).textContent;
		}
		if (p.endDateSelector !== '') {
			p.endDate = document.querySelector(p.endDateSelector).textContent;
		}

		var beginDate = getDateFromParts(p.beginDate);
		var endDate = getDateFromParts(p.endDate);

		var diff = DateDiff.inDays(beginDate, endDate);

		return diff;
	}

	function markEmptyLists(opt) {
		var f = arguments.callee.name;
		var p = {
			listSelector : '.content .protocol-list',
			tag : 'li',
			emptyClass : 'empty-list',
			emptyLabel : 'None'
		};
		if (typeof opt === 'object') {
			p = extend(p, opt);
		}

		dbg.log(dbg.DEBUG, f, 'START listSelector {0}, tag {1}, emptyClass {2}, emptyLabel {3}'.format(p.listSelector, p.tag, p.emptyClass,
				p.emptyLabel));

		list = document.querySelectorAll(p.listSelector);
		for (var i = 0; i < list.length; i++) {
			var item = list[i];
			var children = item.children;

			if (children.length === 0) {
				var html = '<{0} class="{1}">{2}</{0}>'.format(p.tag, p.emptyClass, p.emptyLabel);
				var msg = 'Marking empty item with {0}'.format(html);
				dbg.log(dbg.DEBUG, f, msg);
				item.innerHTML = html;
			}
		}

		dbg.log(dbg.DEBUG, f, 'FINISH');
	}

	// formatLoopData

	// update loop data which occurs in the content region
	// items with class="data" are formatted and written to empty span elements which must follow
	// items containing data are presumed hidden using the "hidden" class
	// data-type specifies input type, defaults to text
	// data-format specifies output type
	// Ex.
	// <label>Sponsor(s):</label>
	//  <span class="data hidden" data-format="commasOxford">dbValue(r_sponsors.sponsor_name_all)</span><span></span>
	//
	// <label>Reviewers(s):</label>
	//  <span class="data hidden" data-format="ul+">dbValue(r_reviews.reviewers_all)</span><span></span>
	//
	// <span class="data hidden" data-type="date">dbValue(r_reviews.approval_start_date)</span><span></span>
	function formatLoopData() {
		var f = arguments.callee.name;

		dbg.log(dbg.DEBUG, f, 'START');

		list = document.querySelectorAll('.content .data');
		for (var i = 0; i < list.length; i++) {
			var item = list[i];

			//console.log(item, item.getAttribute('data-format'));

			var v = formatData({
				inputFormat : initialValue(item.getAttribute('data-type'), 'text'),
				outputFormat : initialValue(item.getAttribute('data-format'), ''),
				exclude : initialValue(item.getAttribute('data-exclude'), ''),
				template : initialValue(item.getAttribute('data-template'), ''),
				replace : initialValue(item.getAttribute('data-replace'), ''),
				replaceWith : initialValue(item.getAttribute('data-replace-with'), ''),
				replaceOutput : initialValue(item.getAttribute('data-replace-output'), false),
				blankValue : initialValue(item.getAttribute('data-blank-value'), ''),
				defaultValue : initialValue(item.getAttribute('data-default-value'), ''),
				input : item.innerHTML
			});
			var target = item.nextSibling;
			if (target.tagName === 'SPAN' && target.innerHTML === '') {
				target.innerHTML = v;
			}
		}

		dbg.log(dbg.DEBUG, f, 'FINISH');
	}

	function stripEmbeddedSectionLabel(s) {
		// admin item section labels look like <b><u><p>Chair and alternates</p></u></b>
		s = s.replace(/^<b><u><p>.*<\/p><\/u><\/b>/, '');
		return s;
	}

	function highlightPlaceholders(s) {
		// placeholders in minutes admin items look like [insert IRB MEMBER NAME]
		s = s.replace(/(\[insert .*?\])/g, '<span class="warn">$1</span>');
		return s;
	}

	function highlightDataFields() {
		list = document.querySelectorAll('span');
		for (var i = 0; i < list.length; i++) {
			var item = list[i];

			var c = item.className;
			if (c) {
				item.insertAdjacentHTML('afterend', ' &larr; <label class="fieldid"> ' + c + '</label>');
				item.classList.add('field-target');
			}
		}
	}

	function getLastDayOfMonth() {
		var date = new Date(), y = date.getFullYear(), m = date.getMonth();
		var firstDay = new Date(y, m, 1);
		var lastDay = new Date(y, m + 1, 0);
		return lastDay;
	}


</script>
